<?php

/*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
* 
* The authors can be contacted at: 
*  - arthur [at] civicactions (dot) com
*  - jonathan [at] civicactions (dot) com
* 
* @license http://www.affero.org/oagpl.html
* @link    http://civications.com
*/

function _media_mover_email_process_date($line) {
  //$time_difference = get_settings('gmt_offset') * 3600;

  $dmonths = array (
    'Jan',
    'Feb',
    'Mar',
    'Apr',
    'May',
    'Jun',
    'Jul',
    'Aug',
    'Sep',
    'Oct',
    'Nov',
    'Dec'
  );

  $ddate = trim($line);
  $ddate = str_replace('Date: ', '', $ddate);
  if (strpos($ddate, ',')) {
    $ddate = trim(substr($ddate, strpos($ddate, ',') + 1, strlen($ddate)));
  }
  $date_arr = explode(' ', $ddate);
  $date_time = explode(':', $date_arr[3]);

  $ddate_H = $date_time[0];
  $ddate_i = $date_time[1];
  $ddate_s = $date_time[2];

  $ddate_m = $date_arr[1];
  $ddate_d = $date_arr[0];
  $ddate_Y = $date_arr[2];
  for ($j = 0; $j < 12; $j++) {
    if ($ddate_m == $dmonths[$j]) {
      $ddate_m = $j +1;
    }
  }

  $time_zn = intval($date_arr[4]) * 36;
  $ddate_U = gmmktime($ddate_H, $ddate_i, $ddate_s, $ddate_m, $ddate_d, $ddate_Y);
  $ddate_U = $ddate_U - $time_zn;
  $post_date = gmdate('Y-m-d H:i:s', $ddate_U + $time_difference);
  $post_date_gmt = gmdate('Y-m-d H:i:s', $ddate_U);

  return $post_date_gmt;
}

/**
 * function for processing the an emails Subject line
 * */
function _media_mover_email_process_subject($line, $phone_delim) {
  $subject = trim($line);
  $subject = substr($subject, 9, strlen($subject) - 9);
  if (!preg_match('#\=\?(.+)\?Q\?(.+)\?\=#i', $subject)) {
    //$subject = wp_iso_descrambler($subject);
  }
  // Captures any text in the subject before $phone_delim as the subject
  $subject = explode($phone_delim, $subject);
  return $subject[0];
}

/**
 * function for processing the an emails Reply-To or From line
 * */
function _media_mover_email_process_user($line,&$from_email) {
  // Set the author using the email address (To or Reply-To, the last used)
  // otherwise use the site admin
  // SDM: added slash to beginning to 2nd preg_match

  $author = trim($line);
  if (ereg("([a-zA-Z0-9\_\-\.]+@[\a-zA-z0-9\_\-\.]+)", $author, $regs)) {
    $logfile .= "Author = {$regs[1]} \r\n";
  }
  $from_email = $regs[0];
  $from_email = str_replace('From:','',$from_email);
  $from_email = str_replace('Reply-To:','',$from_email);
  
  $author = str_replace('From:','',$author);
  $author = str_replace('Reply-To:','',$author);
  return trim($author);
}

/**
 * provide a minimal set of security 
 * (assume this is safer on linux)
 * */
function _media_mover_email_security($the_file, $allowed_extentions = null) {

  // is this sufficient? 
  //@ chmod($the_file, 0600);
  if ($allowed_extentions === null) $allowed_extentions = array();
  
  preg_match('/\.\w+$/',$the_file, $extension);
  $the_extention = (isset($extension[0])) ? str_replace('.','',$extension[0]) :'';
  $the_extention = strtolower($the_extention);
  
  if (!in_array($the_extention,$allowed_extentions)){
    //del file.
    @ unlink($the_file);
    watchdog(MM_EMAIL_WATCHDOG_TYPE,$the_extention.' is not allowed. DELETED'. $the_file,WATCHDOG_WARNING);
    return false;
  }
  else{ 
     // file is ok, set file perms
     media_mover_api_set_file_perm($the_file);
    return true;
  }
}

/**
 * hashing function for creating filename
 * */
 function _media_mover_email_hash_filename($filename, $date){
   // preg_match('/\.\w+$/',$filename, $extension);
   // $the_extention = (isset($extension[0])) ? str_replace('.','',$extension[0]) :'';
   // return md5($filename.$date.time()).'.'.$the_extention;
   return $filename;
 }
 
 /**
 * helper function to parse out the base64 content from an email segment
 * */
function _media_mover_email_get_content_from_segment(&$segment){

  $lines = explode("\n",trim($segment));
  $signal = false;
  $raw_content = '';
  $debug = '';
  
  foreach($lines as $line){
    if ( ord($line) == 13 || ord($line) == 0){
      $signal = true;
    }
//    else if (strlen($line) <=5){
//      echo '<br> ord '.ord($line);
//    }
    
    if($signal){
      $raw_content .= $line;
    }
  }
  
  if ($raw_content == ''){
    $raw_content = $segment;
    //echo '<hr>'.$segment;
  }
  
  return $raw_content;
}