<?php
 
// $Id; 
 

define('MM_FTP_WATCHDOG_TYPE', 'media mover ftp');

/**
 * open questions:
 * 
 * log files?
 * settings - does media mover already have an admin
 * 
 * @param array $file
 * @param array $configuration
 * 
 * @return $files
 * 
 * */
function _media_mover_ftp_harvest(&$file_data_array, $action, $conf) {
  $ftp_conn = ftp_connect($conf['media_mover_ftp_host']);
  $ftp_login = ftp_login($ftp_conn, $conf['media_mover_ftp_user'], $conf['media_mover_ftp_pass']);
  $ftp_list = ftp_rawlist($ftp_conn, $conf['media_mover_ftp_dir']);
  if(!$ftp_conn) {
    watchdog(MM_FTP_WATCHDOG_TYPE, t('Unable to connect to server %server', array('%server' => $conf['media_mover_ftp_host'])), WATCHDOG_ERROR);
    return;
  }
  elseif(!$ftp_login) {
    watchdog(MM_FTP_WATCHDOG_TYPE, t('Unable to login to server %server with username %user', array('%server' => $conf['media_mover_ftp_host'], '%user' => $conf['media_mover_ftp_user'])), WATCHDOG_ERROR);
    return;    
  }
  elseif($ftp_list === FALSE) {
    watchdog(MM_FTP_WATCHDOG_TYPE, t('Unable to get file list from server %server with username %user', array('%server' => $conf['media_mover_ftp_host'], '%user' => $conf['media_mover_ftp_user'])), WATCHDOG_ERROR);
    return;    
  }
  $del = $conf['mm_ftp_delete_files'];
  $file_types = $conf['mm_ftp_allowed_files'];
  $count = count($ftp_list);
  $date = date('Y-m-d H:i:s');
  $_count = ($count) ? $count : 'NO';
 // $message = "$_count items at ". $conf['media_mover_ftp_host'] ." at $date";
 // watchdog(MM_FTP_WATCHDOG_TYPE, $message);
  if ($count == 0) {
    return;
  }
  $logfile = '';
  foreach($ftp_list as $item) {
    $info = array();
    $vinfo = preg_split("/[\s]+/", $item, 9);
    if ($vinfo[0][0] == "-") {
      $info['chmod'] = $vinfo[0];
      $info['name'] = $vinfo[8];
      $info['dir'] = $conf['media_mover_ftp_dir'];
      list($info['hour'], $info['minute']) = split(":", $vinfo[7]);
      $info['hour'] = $info['hour'] + 0; // mktime expects hour to be long, not a string
      $info['minute'] = $info['minute'] + 0; // mktime expects minute to be long, not a string
      $info['month'] = $vinfo[5] + 0; // mktime expects month to be long, not a string
      $info['day'] = $vinfo[6] + 0; // mktime expects day to be long, not a string
      $info['created'] = mktime($info['hour'], $info['minute'], 0, $info['month'], $info['day'], date(Y));
      $info['size'] = $vinfo[4];
      /*
      $info['num'] = $vinfo[1];
      $info['owner'] = $vinfo[2];
      $info['group'] = $vinfo[3];
      $info['time'] = $vinfo[7];
      */
      $success = _media_mover_ftp_process_ftp($file_data_array, $info, $logfile, $ftp_conn, $del, $file_types);
    }
    else {
      // We're not looking at a file but at a directory ("d") or a link ("l") for instance
    }
  }
  ftp_close($ftp_conn);
  return $file_data_array;
}

/**
 * this loops through the message, finds the files 
 */
function _media_mover_ftp_process_ftp(&$file_data_array, &$info, &$logfile, &$ftp_conn, $del, $file_types) {


  $replace_success = _media_mover_ftp_content($file_data_array, $ftp_conn, $file_types, $info, $node);
  if (!empty($del) && !ftp_delete($ftp_conn, $info['dir'] ."/". $info['name'])) {
    watchdog(MM_FTP_WATCHDOG_TYPE, "Error deleting file $item", WATCHDOG_ERROR);
    return FALSE;
  }
  if ($replace_success) {
    return TRUE;
  }
  else {
    return FALSE;
  }
}

/**
 * traverse the data contained in the email looking for relevant parts.
 */
function _media_mover_ftp_content(&$file_data_array, &$ftp_conn, $file_types, $info, $node = NULL) {
  global $mm_ftp_content_count;
  if (empty($mm_ftp_content_count)) {
    $mm_ftp_content_count = 0;  
  }
  
  // the array of info for this specific file
  $file_array = array();
  
  //track the messages' keys for adding body later
  $mm_ftp_content_count_array = array();
  $final_success = FALSE;
  $_file_array = $file_array;
  $final_success = _media_mover_ftp_create_file($_file_array, $ftp_conn, $info, $file_types);
  if($final_success) {
    $mm_ftp_content_count++;
    $file_data_array[$mm_ftp_content_count] = $_file_array; 
  }
  return $final_success;
}

/**
 * function for saving the file from the FTP server to the local drupal directory
 * @param array $file_array
 * @param 
 */
function _media_mover_ftp_create_file(&$file_array, &$ftp_conn, $info, $file_types) {
  
  // try to find a token on the file name
  $pattern = '/\.([0-9a-zA-z]{6})/';
  preg_match($pattern, $info['name'], $matches);

  if ($matches[1]) {
    $token = $matches[1];
    // remove the token so we don't accidently not harvest it
    $local_file = str_replace('.'.$token, '', $info['name']);
  }
  else {
    $local_file = $info['name'];
  }
  
  // get file path from media mover
  $file_location = media_mover_api_dir_path() . MM_FTP_FILES_SUBDIRECTORY;
 
  // look out for dupes
  $local_file_path = file_create_filename($local_file, $file_location);

  // only harvested file types that match the requested types
  if (media_mover_ftp_file_extension_check($local_file,  $file_types)) { 

    // download the file via FTP
    if(!ftp_get($ftp_conn, $local_file_path, "/". $info['dir'] ."/". $info['name'], FTP_BINARY)) {
      watchdog(MM_FTP_WATCHDOG_TYPE, 'FTP file harvest failed downloading: '. $local_file_path);
    }
    
    // run another security check
    // @ TODO needed?
    $success = _media_mover_ftp_security($local_file_path, $file_types);
    if ($success) watchdog(MM_FTP_WATCHDOG_TYPE, 'FTP file harvested: '. $local_file_path);
    $file_array['filesize'] = $info['size'];
    $file_array['filename'] = $local_file;
    $file_array['filepath'] =  $local_file_path;
    $file_array['harvest_module'] = 'media_mover_ftp_harvest';
    $file_array['harvest_action'] = 1;
    $file_array['harvest_file'] = $local_file_path;
    $file_array['node']['title'] = $local_file;
    
    // get a user id the db
    if ( $token) { 
      $uid = db_result(db_query('SELECT uid FROM {media_mover_ftp_tokens} WHERE token = "%s"', $token));  
      if ($uid) { $file_array['user']['uid'] = $uid;}
    }
    
  }
  
  return $success;
}

/**
 * provide a minimal set of security 
 * (assume this is safer on linux)
 * @TODO not sure if this really does us any good- we're not going to harvest
 * files that don't match our extensions already. Maybe the mimedetect library
 * is helpful here, but not sure
 * @param  array $the_file
 * @param array $allowed_extenstions
 */
function _media_mover_ftp_security($the_file, $file_types) {
  $file_types = explode(' ', strtolower($file_types));  
  // is this sufficient? 
  //@ chmod($the_file, 0600);
  if ($file_types === null) $file_types = array();
  preg_match('/\.\w+$/',$the_file, $extension);
  $the_extention = (isset($extension[0])) ? str_replace('.', '', $extension[0]) : '';
  $the_extention = strtolower($the_extention);
  if (!in_array($the_extention, $file_types)){
    //del file.
    @ unlink($the_file);
    watchdog(MM_FTP_WATCHDOG_TYPE, $the_extention .' is not allowed. DELETED'. $the_file, WATCHDOG_WARNING);
    return FALSE;
  }
  else { 
    // file is ok, set file perms
    media_mover_api_set_file_perm($the_file);
    return TRUE;
  }
}


/**
 * this checks a file name's extension against a list of extensions
 * @param string $filename is a file name
 * @param string $extensions is a list of extensions
 * @return boolean
 */
function media_mover_ftp_file_extension_check($filename, $extensions) {
  $path_parts = pathinfo($filename);
  $extension = $path_parts['extension'];
  $file_types = explode(' ', strtolower($extensions)); 
  if (in_array($extension, $file_types)) {
    return true;
  }
  return false;  
}
